//+------------------------------------------------------------------+
//|                                                   FXG_iMaFan.mq4 |
//|                                                 FXGeneral, 2010 |
//|                                        http://www.fxgeneral.com/ |
//+------------------------------------------------------------------+
#property copyright "FXGeneral, 2010"
#property link      "http://www.fxgeneral.com/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Blue
#property indicator_color4 Violet
#property indicator_color5 DodgerBlue
#property indicator_color6 Blue
#property indicator_color7 DarkViolet
#property indicator_color8 Black


//----  
extern bool show_fan=true;
extern bool show_labels=true;
extern int  labels_width=1;
extern int bar=21;
extern int ma1=21;
extern int ma2=34;
extern int ma3=55;
extern int ma4=89;
extern int ma5=144;
extern int ma6=233;
extern int ma7=377;
extern int ma8=610;
extern int width=2;
extern string _ma ="0-SMA,1-EMA,2-SMMA,3-LWMA";
extern double ma_method = MODE_SMMA;
extern string _ ="0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted";
extern double price_type_ma = PRICE_WEIGHTED;

extern bool show_ma1=true;
extern bool show_ma2=true;
extern bool show_ma3=true;
extern bool show_ma4=true;
extern bool show_ma5=true;
extern bool show_ma6=true;
extern bool show_ma7=true;
extern bool show_ma8=true;

//---- indicator buffers
double ExtRedBuffer[];
double ExtOrangeBuffer[];
double ExtYellowBuffer[];
double ExtGreenBuffer[];
double ExtDodgerBlueBuffer[];
double ExtBlueBuffer[];
double ExtDarkVioletBuffer[];
double ExtBlackBuffer[];

int init()
  {
if(bar<2) bar=2; 
if(bar>Bars)bar=Bars; 
if(show_fan==true)
{  
   SetIndexDrawBegin(0,Bars-bar);
   SetIndexDrawBegin(1,Bars-bar);
   SetIndexDrawBegin(2,Bars-bar);
   SetIndexDrawBegin(3,Bars-bar);
   SetIndexDrawBegin(4,Bars-bar);
   SetIndexDrawBegin(5,Bars-bar);  
   SetIndexDrawBegin(6,Bars-bar);
   SetIndexDrawBegin(7,Bars-bar);

   SetIndexBuffer(0,ExtRedBuffer);
   SetIndexBuffer(1,ExtOrangeBuffer);
   SetIndexBuffer(2,ExtYellowBuffer);
   SetIndexBuffer(3,ExtGreenBuffer);
   SetIndexBuffer(4,ExtDodgerBlueBuffer);
   SetIndexBuffer(5,ExtBlueBuffer);
   SetIndexBuffer(6,ExtDarkVioletBuffer);
   SetIndexBuffer(7,ExtBlackBuffer);
   
//---- drawing settings

   SetIndexStyle(0,DRAW_LINE,0,width);
   SetIndexStyle(1,DRAW_LINE,0,width);
   SetIndexStyle(2,DRAW_LINE,0,width);
   SetIndexStyle(3,DRAW_LINE,0,width);
   SetIndexStyle(4,DRAW_LINE,0,width);
   SetIndexStyle(5,DRAW_LINE,0,width);
   SetIndexStyle(6,DRAW_LINE,0,width);
   SetIndexStyle(7,DRAW_LINE,0,width);

//---- index labels
   SetIndexLabel(0,"MA-"+ma1+"");
   SetIndexLabel(1,"MA-"+ma2+"");
   SetIndexLabel(2,"MA-"+ma3+"");
   SetIndexLabel(3,"MA-"+ma4+"");
   SetIndexLabel(4,"MA-"+ma5+"");
   SetIndexLabel(5,"MA-"+ma6+"");
   SetIndexLabel(6,"MA-"+ma7+"");
   SetIndexLabel(7,"MA-"+ma8+"");
} 
   
//---- initialization done
   return(0);
  }
int deinit()
 {
  delete_labels();
  return(0);
 }  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
     {
      //---- ma_shift set to 0 because SetIndexShift called abowe
if(show_ma1==true)     ExtRedBuffer[i]=iMA(NULL,0,ma1,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma1+"",ExtRedBuffer[i],indicator_color1);
if(show_ma2==true)      ExtOrangeBuffer[i]=iMA(NULL,0,ma2,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma2+"",ExtOrangeBuffer[i],indicator_color2);
if(show_ma3==true)      ExtYellowBuffer[i]=iMA(NULL,0,ma3,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma3+"",ExtYellowBuffer[i],indicator_color3);
if(show_ma4==true)      ExtGreenBuffer[i]=iMA(NULL,0,ma4,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma4+"",ExtGreenBuffer[i],indicator_color4);
if(show_ma5==true)      ExtDodgerBlueBuffer[i]=iMA(NULL,0,ma5,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma5+"",ExtDodgerBlueBuffer[i],indicator_color5);
if(show_ma6==true)      ExtBlueBuffer[i]=iMA(NULL,0,ma6,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma6+"",ExtBlueBuffer[i],indicator_color6);
if(show_ma7==true)      ExtDarkVioletBuffer[i]=iMA(NULL,0,ma7,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma7+"",ExtDarkVioletBuffer[i],indicator_color7);
if(show_ma8==true)      ExtBlackBuffer[i]=iMA(NULL,0,ma8,0,ma_method,price_type_ma,i);
if(show_labels==true)   create_label("MA"+ma8+"",ExtBlackBuffer[i],indicator_color8);
  
     }
     
//---- done
   return(0);
  }
//+------------------------------------------------------------------+
void create_label(string name,double price,color _color)
 {
 datetime time;
 time=iTime(Symbol(),Period(),0);
  ObjectCreate(name,OBJ_ARROW,0,time,price,time,price);
  ObjectSet(name,OBJPROP_ARROWCODE,6);
  ObjectSet(name,OBJPROP_WIDTH,labels_width);
  ObjectSet(name,OBJPROP_COLOR,_color);
    
 }
void delete_labels()
 {
  if(ObjectFind("MA"+ma1+"")!=-1 ||
     ObjectFind("MA"+ma2+"")!=-1 ||
     ObjectFind("MA"+ma3+"")!=-1 ||
     ObjectFind("MA"+ma4+"")!=-1 ||
     ObjectFind("MA"+ma5+"")!=-1 ||
     ObjectFind("MA"+ma6+"")!=-1 ||
     ObjectFind("MA"+ma7+"")!=-1 ||
     ObjectFind("MA"+ma8+"")!=-1 )
    {
    ObjectDelete("MA"+ma1+"");
    ObjectDelete("MA"+ma2+"");
    ObjectDelete("MA"+ma3+"");
    ObjectDelete("MA"+ma4+"");
    ObjectDelete("MA"+ma5+"");
    ObjectDelete("MA"+ma6+"");
    ObjectDelete("MA"+ma7+"");
    ObjectDelete("MA"+ma8+"");
    }   
 }